/*
 * adc7766.h
 */

#ifndef _BF_AD7766_H
#define _BF_AD7766_H

#include <asm/bfin_sport.h>
//#include <sys/mman.h>
//#include <fract.h>

#define ADC_USE_PMEM

// bfin physical (non-kernel) memory region, defined in uboot using:
// setenv bootargs root=/dev/mtdblock0 rw mem=32M max_mem=64M$# console=ttyBF0,115200
//#define BFIN_PMEM_START 0x2001000 /* use when mem=32M */
#define BFIN_PMEM_START 0x3001000   /* use when mem=48M */
#define BFIN_PMEM_END 0x4000000     /* use when max_mem=64M */
#define BFIN_PMEM_SIZE (BFIN_PMEM_END - BFIN_PMEM_START)


// sport adc parameters
struct adc_struct {
   char device[32];  // file name
   int fd;
   int nbufs;        // number of buffer
   int nsize;        // buffer sample size in bytes
   int nchans;       // buffer num of channels
   int nsamps;       // buffer num of samples
   int fs;           // buffer sampling freq [hz]
   int gain;         // pre-amp gain 
   int shift;        // scaling bit shift 
   int auto_scale;   // auto scaling 
   int clip;         // data clipping detected 
   struct timespec time; // sample start time
   struct sport_dma_buffer dma_buffer; // dma buffer
   char *buffer[SPORT_MAX_NUM_DMA_BUFS];  // dma data buffers
};
typedef struct adc_struct adc_t;

extern adc_t *ad7766_open(char *device, int fs);
extern int ad7766_alloc_dma_buffers(adc_t *adc, float adc_duration, int adc_nsize);
extern int ad7766_start_clock(adc_t *adc);
extern int ad7766_start_dma(adc_t *adc);
extern int ad7766_stop_dma(adc_t *adc);
extern int ad7766_read_dma(adc_t *adc, char **buffer);
extern int ad7766_read(adc_t *adc, char *buf, int nsamps, int nsize);
extern int ad7766_scale(adc_t *adc, char *buf);
extern void ad7766_close(adc_t *adc);

#endif /* _BF_AD7766_H */

