/*
 *  led.c:  LED controls
 *
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "led.h"

int led_open()
{
   // open gpio lines for LED control
   gpio_export(GPIO_LED1); 
   gpio_dir_out(GPIO_LED1); 
   gpio_export(GPIO_LED2); 
   gpio_dir_out(GPIO_LED2);
   gpio_export(GPIO_LED3); 
   gpio_dir_out(GPIO_LED3);

   // turn OFF
   gpio_write(GPIO_LED1, 0);
   gpio_write(GPIO_LED2, 0);
   gpio_write(GPIO_LED3, 0);

   return(1);
}

void led_set_on(int num)
{
   if(num == 1) gpio_write(GPIO_LED1, 1);
   if(num == 2) gpio_write(GPIO_LED2, 1);
   if(num == 3) gpio_write(GPIO_LED3, 1);
   if((num <= 0) || (num > 3)) {
      fprintf(stdout, "led_set_on: Unknown LED number\n");
   }
};

void led_set_off(int num)
{
   if(num == 1) gpio_write(GPIO_LED1, 0);
   if(num == 2) gpio_write(GPIO_LED2, 0);
   if(num == 3) gpio_write(GPIO_LED3, 0);
   if((num <= 0) || (num > 3)) {
      fprintf(stdout, "led_set_off: Unknown LED number\n");
   }
};

void led_close()
{
   // turn OFF
   gpio_write(GPIO_LED1, 0);
   gpio_write(GPIO_LED2, 0);
   gpio_write(GPIO_LED3, 0);

   gpio_unexport(GPIO_LED1);
   gpio_unexport(GPIO_LED2);
   gpio_unexport(GPIO_LED3);
};


