/*
 * Wave file functions
*/

struct WaveFile {
  char ChunkID[4];
  char Format[4];
  char Subchunk1ID[4];
  char Subchunk2ID[4];
  int ChunkSize;
  int Subchunk1Size;
  int SampleRate;
  int ByteRate;
  int Subchunk2Size;
  short AudioFormat;
  short NumChannels;
  short BlockAlign;
  short BitsPerSample;
  short *Data;
  int nsamps;
  int nsize;
};

extern size_t bwrite(char *ptr, size_t bsize, size_t nbytes, FILE *stream);

extern int wave_read_header(FILE *fp, struct WaveFile *wave);
extern int wave_write_header(FILE *fp, struct WaveFile *wave);
extern int wave_read(char *file, struct WaveFile *wave, short *buffer);
extern int wave_read_char(char *file, struct WaveFile *wave, short *buffer, int nsamps, int nsize, int offset);
extern int wave_write(char *file, struct WaveFile *wave);
extern int wave_append(char *file, struct WaveFile *wave,char *data,int nsamps,int nsize);
extern int wave_info(char *file, struct WaveFile *wave);

